
#define TEXTURE_1D 0
#define TEXTURE_2D 1
#define TEXTURE_3D 2
#define TEXTURE_CUBE_MAP 3
#define TEXTURE_RECT 4
#ifndef TEXTURE_TYPE
#    define TEXTURE_TYPE TEXTURE_2D
#endif
#if GL_ES
#    if TEXTURE_TYPE == TEXTURE_3D && !defined(GL_OES_texture_3D)
#	define REDEFINE_TEXTURE_2D
#    elif TEXTURE_TYPE == TEXTURE_RECT
#	define REDEFINE_TEXTURE_2D
#    elif TEXTURE_TYPE == TEXTURE_1D
#	define REDEFINE_TEXTURE_2D
#    endif
#endif
#ifdef REDEFINE_TEXTURE_2D
uniform lowp    sampler2D texture;
#elif TEXTURE_TYPE == TEXTURE_3D
#    if GL_ES
#        extension GL_OES_texture_3D : enable
#    endif
uniform lowp    sampler3D texture;
#elif TEXTURE_TYPE == TEXTURE_CUBE_MAP
uniform lowp    samplerCube texture;
#elif TEXTURE_TYPE == TEXTURE_RECT
#    if GL_ES
#        error texture rectangle not supported with GLES2
#    else
#        extension GL_ARB_texture_rectangle : enable
#    endif
uniform lowp    sampler2DRect texture;
#elif TEXTURE_TYPE == TEXTURE_1D
uniform lowp    sampler1D texture;
#else
uniform lowp    sampler2D texture;
#endif
#ifdef REDEFINE_TEXTURE_2D
varying mediump vec2 vCoord0;
#elif TEXTURE_TYPE == TEXTURE_3D || TEXTURE_TYPE == TEXTURE_CUBE_MAP
varying mediump vec3 vCoord0;
#else
varying mediump vec2 vCoord0;
#endif
void main()
{
#ifdef REDEFINE_TEXTURE_2D
    gl_FragColor = texture2D(texture, vCoord0);
#elif TEXTURE_TYPE == TEXTURE_3D
    gl_FragColor = texture3D(texture, vCoord0);
#elif TEXTURE_TYPE == TEXTURE_CUBE_MAP
    gl_FragColor = textureCube(texture, vCoord0);
#elif TEXTURE_TYPE == TEXTURE_RECT
    gl_FragColor = texture2DRect(texture, vCoord0);
#elif TEXTURE_TYPE == TEXTURE_1D
    gl_FragColor = texture1D(texture, vCoord0.x);
#else
    gl_FragColor = texture2D(texture, vCoord0);
#endif
}