uniform lowp sampler2D TextureSampler;
uniform lowp sampler2D TextureSamplerCb;
uniform lowp sampler2D TextureSamplerCr;
uniform lowp vec4 DiffuseColor;
uniform lowp vec4 AdditiveColor;

varying highp vec2 vTexCoord0;
varying lowp vec4 vColor0;

void main()
{
	lowp vec3 YCbCr = vec3(texture2D(TextureSampler, vTexCoord0,-8.0).a, texture2D(TextureSamplerCb, vTexCoord0,-8.0).a, texture2D(TextureSamplerCr, vTexCoord0,-8.0).a);
	
	lowp float R = 1.164 * (YCbCr.x - 0.0627)                           + 1.596 * (YCbCr.z - 0.5);
	lowp float G = 1.164 * (YCbCr.x - 0.0627) - 0.392 * (YCbCr.y - 0.5) - 0.813 * (YCbCr.z - 0.5);
	lowp float B = 1.164 * (YCbCr.x - 0.0627) + 2.017 * (YCbCr.y - 0.5);
	lowp vec4 color = vec4(R, G, B, 1.0);
	
	color *= vColor0;

	gl_FragColor = color + AdditiveColor;
}
